<?php
namespace Teknisa\Entities;

use Geral\Util\DateUtil;
class SitLogtek extends Base\SitLogtek
{

	
	public function insereLog($nrorgInt, $remessaInt, $produtoInt, $remessaOri){
		$this->setNrorgint($nrorgInt);
		$this->setNrremessaint($remessaInt);
		$this->setCdprodutoint($produtoInt);
        $this->setNrremessaori($remessaOri);
		$this->setDtenvio(DateUtil::getDataAtual());
		
		$this->persist();
	}

    /**
     * @param String $nrorg        Organização
     * @param String $nrorgint     Organização Integração
     * @param String $nrremessaint Número Remessa
     * @param String $nrremessaori Número Remessa Origem
     * @param String $cdprodutoint Código do Produto
     * @param String $dtAtual      Data Atual
     * @param String $cdoperador   Operador
     *
     * @return null
     */
    public static function geraLogTek (
        $nrorg, $nrorgint, $nrremessaint, $nrremessaori,
        $cdprodutoint, $dtAtual, $cdoperador
    ) {

        $logtek = self::getObjectByWhere(
            "NRORG = ? AND NRORGINT = ? AND NRREMESSAINT = ?
             AND NRREMESSAORI = ? AND CDPRODUTOINT = ?",
            array($nrorg, $nrorgint, $nrremessaint, $nrremessaori, $cdprodutoint)
        );

        if (!$logtek instanceof self) {
            $logtek = new self();
            $logtek->setNrorg($nrorg);
            $logtek->setNrorgint($nrorgint);
            $logtek->setNrremessaint($nrremessaint);
            $logtek->setNrremessaori($nrremessaori);
            $logtek->setCdprodutoint($cdprodutoint);
        }

        $logtek->setDtenvio($dtAtual);
        //
        $logtek->setNrorginclusao($nrorg);
        $logtek->setNrorgultatu($nrorg);
        $logtek->setDtinclusao($dtAtual);
        $logtek->setDtultatu($dtAtual);
        $logtek->setCdoperinclusao($cdoperador);
        $logtek->setCdoperultatu($cdoperador);
        $logtek->setIdativo('S');

        $logtek->persist();
    }

}